#pragma once
#include "InvCompAlgorithm.h"

// ,        
// (  ).     
//     .
class CPixelMappingModel3DOF : public CPixelMappingModel
{
public:

  // .
  CPixelMappingModel3DOF();  

  // .
  ~CPixelMappingModel3DOF();
  
  /*   ,   CPixelMappingModel. */

  int GetParamCount();
  
  bool MapPixel(
    CvPoint2D32f* pSrcPixel, 
    CvPoint2D32f* pDstPixel
   );
  
  bool Reset();

  bool Update(
    CvMat* pMatParams
    );
  
  bool CalcJacobianMat(
    CvMat* pMatJacobian,
    CvPoint2D32f* pPixel
   );  

  //     .
  CvMat* GetComposition();

  //     (fOffsX, fOffsY) 
  //    fRotAngle  .
  bool ExtractParams(
    CvPoint2D32f ptRotCenter, // [in] ,    .
    float& fRotAngle,  // [out]     .
    float& fOffsX,     // [out]    OX.
    float& fOffsY      // [out] C   OY.
   );

private:

  /* ,   . */

  CvMat* m_pMatComposition; //     3 x 3.  
  CvMat* m_pMatTwist;       // - 3 x 3.
  CvMat* m_pMatA;           //    3 x 3.
};
