#pragma once
#include <vector>
#include <assert.h>
#include <time.h>

//      .
class CTimeMeter
{
public:

  CTimeMeter(bool bAutoStart = false)
  {
    if(bAutoStart)
      m_dStartTime = clock();
    else
      m_dStartTime = 0;

    m_dFinishTime = 0;    
  }
  
  void Start()
  {
    m_dStartTime=clock();
  }

  double Finish()
  {
    double dFinishTime = clock();
    double dDuration = (dFinishTime - m_dStartTime)/CLOCKS_PER_SEC;
    return dDuration;
  }

private:

 double m_dStartTime;
 double m_dFinishTime;
};

// ,       .
class CStatSample
{
public:

  CStatSample(); 
  ~CStatSample();
  
  //    .
  void AddValue(double Xi);  

  //  i-  .
  double GetValue(int i);

  //   .
  size_t GetSize();

  //    .
  double GetMinimumValue();

  //    .
  double GetMaximumValue();

  //    .
  double GetMeanValue();

  //   .
  double GetStdDev();

  //    .
  double GetSampleStdDev();

  //      .
  void PrintStat(FILE* f, char* stat_name);

private:

  //   .
  void CalcMoments();  

  bool m_bCalculated;
  double m_fMinimum;      //   .
  double m_fMaximum;      //   .
  double m_fMean;         // .  (mean)
  double m_fVariance;     //  (sigma^2)
  double m_fStdDev;       //   (sigma)
  double m_fSampleStdDev; //  .  (s)
  
  std::vector<double> m_sample; //  .
};

