#pragma once
#include <stdio.h>
#include <tchar.h>
#include <time.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include <cv.h>
#include <highgui.h>
#include "InvCompAlgorithm.h"
#include "PixelMapping3DOF.h"
#include "StatFunc.h"

// ,     
// -   .
class CTest
{
public:

  CInvCompRegistrationAlgorithm m_ImgRegAlg; //  .
  CPixelMappingModel3DOF m_PixelMapping;     //   .
  CvMat* m_pMatPrevParams;                   //    .
  CvMat* m_pMatNewParams;                    //    .

  // .
  CTest();

  // .
  ~CTest();

  //        
  // .    ,    
  //    ,    
  //       ( 
  // c ).
  //    :
  //  -     ;
  //  -         ;
  //  -       
  //   .
  void RunStepByStepDemo();

  //       .
  // 1.       .
  // 2.         I1, I2.
  // 3.   I1  I2 (        ).
  // 4.   ,  ,  .
  void RunPerformanceTest();

  //       . ,
  //     .
  void RunCorrectnessTest();

private:

  //    I1, I2   .
  // I1   . I2    I1.
  bool CreateTestImages(
    char* szFileName,     // [in]    .
    CvRect* prcROI,       // [in]   .
    float fRotAngle,      // [in]  .
    float fOffsX,         // [in]    OX.
    float fOffsY,         // [in]    OY.
    IplImage** ppImgI1,   // [out]  I1.
    IplImage** ppImgConfMap,  // [out]    I1.
    IplImage** ppImgI2    // [out]  I2.
    );

  //       
  //           
  //   pMatWarp        
  //    pMatEstimatedWarp.  
  float CalcImageRegistrationAccuracy(
    CvRect& rcROI,    // [in] ,      .
    CvMat* pMatWarp,  // [in]   .
    CvMat* pMatEstimatedWarp // [in]  ,    .
    );

  //      .
  CvPoint2D32f WarpPoint(CvPoint2D32f* pSrcPoint, CvMat* pMatWarp);

  //  ,    
  //      .
  void DrawWarpedRect(
    IplImage* pImg, // [in] ,   .
    CvRect& rc,     // [in] .
    CvMat* pMatWarp // [in]  .
    );

  void TestPixelMapping3DOF();
  void TestInterpolatePixel();
  void TestWarpImageI2();
  void TestIsInnerLoopReady();
  void TestIsReady();
};

#define TEST_ASSERT(expr) if(!(expr)) { printf("ASSERTION FAILED IN FUNCTION:"\
  __FUNCSIG__ "EXPRESSION:" #expr "\n"); return; }
